import java.util.ArrayList;
import java.lang.reflect.Array;

/**
 * Die Klasse Suche implementiert auf einfache Weise, nicht wirklich OO
 * die Tiefensuchen zum CLP.
 * 
 * @author (claus albowski) 
 * @version (Sept '10)
 */
public class Suche
{
    ArrayList<Integer> container; 
    int fassungsvermoegen,inhalt;
    ArrayList<Integer> stuecke;

    /**
     * Konstruktor fr Objekte der Klasse Suche
     */
    public Suche(int containerGroesse)
    {
       stuecke = new ArrayList();
       container = new ArrayList();
       fassungsvermoegen = containerGroesse;
       inhalt = 0;
    }

    /**
     * initialisiert die Stueckeliste nach der Liste von int - Werten.
     */
    public void initStuecke(int[] werte)
    {
        stuecke = new ArrayList();
        for (int i=0; i<Array.getLength(werte); i++) stuecke.add(new Integer(werte[i]));
    }
    
    /**
     * zeigt den Container an.
     */
    public int[] zeigeContainer(){
        int[] ergebnis = new int[container.size()];
        System.out.println("Inhalt des Containers mit "+fassungsvermoegen+" Fassungsvermoegen: ");
        for (int i=0; i<container.size(); i++) {
            ergebnis[i]=container.get(i).intValue();
            System.out.println(ergebnis[i]);
        }
        return ergebnis;
    }
    
    /**
     * fuehrt die greedy Suche durch.
     */
    public void greedySuche(){
         for (int i=0; i<stuecke.size(); i++) 
         if (stuecke.get(i).intValue()+inhalt<=fassungsvermoegen) {
             container.add(stuecke.get(i));
             inhalt+=stuecke.get(i).intValue();
            }
    }
    /**
     * fuehrt die Suche durch.
     */
    public boolean tiefenSuche(int i){
        if (inhalt>fassungsvermoegen) return false;
        else if (inhalt==fassungsvermoegen) return true;
        else if (i==stuecke.size()) return false; 
       else {
           // aktuelles Stueck hineinpacken
           container.add(stuecke.get(i));
           inhalt+=stuecke.get(i).intValue();
           if (tiefenSuche(i+1)) return true;
           container.remove(stuecke.get(i));
           inhalt-=stuecke.get(i).intValue();
           if (tiefenSuche(i+1)) return true;
           return false;
        }
    }
}
